//--------------------------------------------------------------
//      FFT ŏݍݏs߂̃NX
//      \ ConvolverFFT NX̃o֐̒` \
//--------------------------------------------------------------
#include "ConvolverFFT.hpp"

//--------------------------------------------------------------
//      RXgN^
//--------------------------------------------------------------
ConvolverFFT::ConvolverFFT(const int nCoefs, const int nFFT,
                           const float hm[])
             : FFT_N(nFFT), IFFT_N(-nFFT), Hk(nFFT), Xk(nFFT),
               M(nCoefs), N(nFFT)
{
// tB^W DFT  FFT ŌvZ
    for (int n=0; n<M; n++) Hk[n] = hm[n];
    for (int n=M; n<N; n++) Hk[n] = 0.0; // W̌ւ0l
    FFT_N.Execute(Hk, Hk);               // FFT ̎s
}

//--------------------------------------------------------------
//      FFT 𗘗pzݍ
//--------------------------------------------------------------
void ConvolverFFT::Execute(const float xn[], float yn[])
{
    for (int n=0; n<N; n++) Xk[n] = xn[n];
    FFT_N.Execute(Xk, Xk);               // FFT ̎s

    for (int k=0; k<=N/2; k++)
        Xk[k] = Xk[k]*Hk[k];             // g̈ł̕fZ
    for (int k=N/2+1; k<N; k++)
        Xk[k] = Conj(Xk[N-k]);           // f𗘗p

    IFFT_N.Execute(Xk, Xk);              // t FFT ̎s
    for (int n=0; n<N; n++)
        yn[n] = Real(Xk[n]);             // ̎o
}
