//-----------------------------------------------------------------------
//    FFT gdێ@ɂ FIR tB^ \ DSP/BIOS gp |
//          FFT ̃f[^F         256
//          FIR tB^̌W̐F 111 Fʉ߃tB^iLPFj
//                                   105 Fʉ߃tB^iHPFj
//  Ӂ
//  Build Option -> Compiler -> Advanced ŁC-mi1000 w肷邱
//-----------------------------------------------------------------------
#include "Conf_OLScfg.h"            // DSP/BIOS Configuration c[
                                    // 쐬ꂽCN[ht@C
#include "myDSK6713_DSP_BIOS.hpp"
#include "OLSclass.hpp"             // dێ@̂߂̃NX
#include "LargeLoad.hpp"            // 傫ȕׂ^邽߂Ɏgp
#include "Coefficients.hpp"         // tB^W
#include "SetMailbox.hpp"           // mailbox ݒ̂

const int nFFT = 256;               // FFT ̃f[^

// CODEC pIuWFNg
AIC23_6713_DSP_BIOS codec;

// dێ@ FIR tB^̏sIuWFNg
// nLPF, hmLPF, nHPF, hmHPF  "Coeffients.hpp" ̒Œ`
OLS_FIR firLPF(nLPF, nFFT, hmLPF);  // LPF p
OLS_FIR firHPF(nHPF, nFFT, hmHPF);  // HPF p

//-------------------------------------------------------------------
//                  main() ֐
//-------------------------------------------------------------------
int main()
{
    DSK6713_rset(DSK6713_USER_REG, 0);      // LED ̏
    SetMailbox(&SWI_LPF_Xfer, nFFT-nLPF+1); // mailbox ̐ݒ
    SetMailbox(&SWI_HPF_Xfer, nFFT-nHPF+1); // mailbox ̐ݒ

    IRQ_enable(IRQ_EVT_RINT1);      // McBSP1 ̎M荞݋
}
// main() ֐̏ICDSP/BIOS ̃XPW[N

//-------------------------------------------------------------------
//    McBSP1 ̎M݁iHWI_INT11jɑ΂T[rX[`
//-------------------------------------------------------------------
void RX_ISR()
{
    SWI_post(&SWI_IO);      // McBSP1 ̎M荞ݔʒm
}

//-------------------------------------------------------------------
//    \tgEFA SWI_IO ɑ΂T[rX[`
//-------------------------------------------------------------------
void IO()
{
    float xL, yL, xR, yR;

//----- Mo͂̏FJn -----
    codec.Read(xL, xR);     // AD ϊ킩
    yL = firLPF.BufIO(xL);  // `lFLPF ɑ΂o͏
    yR = firHPF.BufIO(xR);  // E`lFHPF ɑ΂o͏
    codec.Write(yL, yR);    // DA ϊ֏o

// mailbox  -1 C0 Ȃ LPF_Xfer() ̎sv
    SWI_dec(&SWI_LPF_Xfer);
// mailbox  -1 C0 Ȃ HPF_Xfer() ̎sv 
    SWI_dec(&SWI_HPF_Xfer); 
}

//-------------------------------------------------------------------
//    \tgEFA SWI_LPF_Xfer ɑ΂T[rX[`
//-------------------------------------------------------------------
void LPF_Xfer()
{
    firLPF.Xfer();          // f[^̓]s
    SWI_post(&SWI_LPF_Exe); // LPF_Exe() ̎sv
}

//-------------------------------------------------------------------
//    \tgEFA SWI_LPF ɑ΂T[rX[`
//-------------------------------------------------------------------
void LPF_Exe()
{
    firLPF.Execute();       // tB^̌vZs
}

//-------------------------------------------------------------------
//    \tgEFA SWI_HPF_Xfer ɑ΂T[rX[`
//-------------------------------------------------------------------
void HPF_Xfer()
{
    firHPF.Xfer();          // f[^̓]s
    SWI_post(&SWI_HPF_Exe); // HPF_Exe() ̎sv
}

//-------------------------------------------------------------------
//    \tgEFA SWI_HPF ɑ΂T[rX[`
//-------------------------------------------------------------------
void HPF_Exe()
{
    firHPF.Execute();       // tB^̌vZs
}

//-------------------------------------------------------------------
//    PRD0 ɑ΂銄݃T[rX[`
//    | ݎF 200 ms |
//-------------------------------------------------------------------
void LED_Drive()
{
    static short LEDs = 0;

    DSK6713_rset(DSK6713_USER_REG, LEDs);
    LEDs = ++LEDs & 0xF;
    LargeLoad(5000);        // 傫ȕ
}

